VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3240
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   ScaleHeight     =   3240
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   3255
      Left            =   0
      ScaleHeight     =   3195
      ScaleWidth      =   4635
      TabIndex        =   0
      Top             =   0
      Width           =   4695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const GRAB_WID = 6

Private m_X(0 To 1) As Single
Private m_Y(0 To 1) As Single

Private m_GrabbedPoint As Integer
' Draw the lines.
Private Sub DrawLines()
Dim i As Integer

    picCanvas.Cls

    ' Draw the lines.
    picCanvas.Line (m_X(0), m_Y(0))-(m_X(1), m_Y(1))

    ' Draw grab handles.
    picCanvas.DrawMode = vbInvert
    For i = 0 To 1
        picCanvas.Line (m_X(i) - GRAB_WID / 2, m_Y(i) - GRAB_WID / 2)-Step(GRAB_WID, GRAB_WID), , BF
    Next i
    picCanvas.DrawMode = vbCopyPen
End Sub

Private Sub Form_Load()
    picCanvas.AutoRedraw = True
    picCanvas.ScaleMode = vbPixels

    m_GrabbedPoint = -1
    m_X(0) = picCanvas.ScaleWidth * 0.25
    m_Y(0) = picCanvas.ScaleHeight * 0.25
    m_X(1) = picCanvas.ScaleWidth * 0.75
    m_Y(1) = picCanvas.ScaleHeight * 0.75
    DrawLines
End Sub

Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer

    ' See if this is a point.
    m_GrabbedPoint = -1
    For i = 0 To 1
        ' See if the point is within the point.
        If Abs(X - m_X(i)) <= GRAB_WID / 2 And _
           Abs(Y - m_Y(i)) < GRAB_WID / 2 _
        Then
            ' This is the point.
            m_GrabbedPoint = i
            Exit For
        End If
    Next i
End Sub


Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if no point is grabbed.
    If m_GrabbedPoint < 0 Then Exit Sub

    ' Save the new coordinates.
    m_X(m_GrabbedPoint) = X
    m_Y(m_GrabbedPoint) = Y

    ' Draw the moved point.
    DrawLines
End Sub
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_GrabbedPoint = -1
End Sub
Private Sub Form_Resize()
Dim i As Integer

    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
    For i = 0 To 1
        If m_X(i) > picCanvas.ScaleWidth Then m_X(i) = picCanvas.ScaleWidth
        If m_Y(i) > picCanvas.ScaleHeight Then m_Y(i) = picCanvas.ScaleHeight
    Next i

    DrawLines
End Sub
